; stem version --> http://www.schnada.de/progn/hax.html#doedel

;;; The principal structures (modules) are those implementing the interfaces
;;; DOEDEL-FACE, ELTERN-FACE, and also TAGGERS-FACE.
;;;   For a brief description of what a structure contains, consult the
;;; comment preceding the interface definition.  For more look up the
;;; Readme and source files.

;;; Interfaces

;; sexponential HTML 
(define-interface doedel-face
  (export (doedelite :syntax)
	  (doedel :syntax)
	  (extend-doedel :syntax)
	  (define-doedel-syntax :syntax)
	  doedel*
	  dt-html4s dt-html4l dt-html4f))

;; macros defining procedural and macroidal HTML element emitters
(define-interface taggers-face
  (export emit-komment emit-bracket emit-punct
	  (define-bracket :syntax) (define-punct :syntax)))

;; procedural and macroidal adapters
;;   current output --> ports or strings
(define-interface tourp-face
  (export screw-on-outport-adapter
	  (with-current-opout-tourp :syntax)))

;; miscellaneous rather than meritorious macros
(define-interface syntuls-face
  (export (with-renames :syntax)
	  (def-renames :syntax)))

(define-interface listuls-face
  (export pair-map))

;; string lities
(define-interface struls-face
  (export relative-tail relative-tailx))

;; procedural and macroidal HTML element emitters.
(define-interface eltern-face
  (export emit-comment* (emit-comment :syntax)
	  emit-area* (emit-area :syntax)
	  emit-base* (emit-base :syntax)
	  emit-br* (emit-br :syntax)
	  emit-col* (emit-col :syntax)
	  emit-hr* (emit-hr :syntax)
	  emit-img* (emit-img :syntax)
	  emit-input* (emit-input :syntax)
	  emit-link* (emit-link :syntax)
	  emit-meta* (emit-meta :syntax)
	  emit-basefont* (emit-basefont :syntax)
	  emit-isindex* (emit-isindex :syntax)
	  emit-a* (emit-a :syntax)
	  emit-b* (emit-b :syntax)
	  emit-bdo* (emit-bdo :syntax)
	  emit-big* (emit-big :syntax)
	  emit-del* (emit-del :syntax)
	  emit-dfn* (emit-dfn :syntax)
	  emit-em* (emit-em :syntax)
	  emit-i* (emit-i :syntax)
	  emit-ins* (emit-ins :syntax)
	  emit-kbd* (emit-kbd :syntax)
	  emit-q* (emit-q :syntax)
	  emit-small* (emit-small :syntax)
	  emit-span* (emit-span :syntax)
	  emit-strong* (emit-strong :syntax)
	  emit-sub* (emit-sub :syntax)
	  emit-sup* (emit-sup :syntax)
	  emit-tt* (emit-tt :syntax)
	  emit-var* (emit-var :syntax)
	  emit-font* (emit-font :syntax)
	  emit-s* (emit-s :syntax)
	  emit-strike* (emit-strike :syntax)
	  emit-u* (emit-u :syntax)
	  emit-abbr* (emit-abbr :syntax)
	  emit-acronym* (emit-acronym :syntax)
	  emit-address* (emit-address :syntax)
	  emit-blockquote* (emit-blockquote :syntax)
	  emit-body* (emit-body :syntax)
	  emit-button* (emit-button :syntax)
	  emit-caption* (emit-caption :syntax)
	  emit-cite* (emit-cite :syntax)
	  emit-code* (emit-code :syntax)
	  emit-colgroup* (emit-colgroup :syntax)
	  emit-dd* (emit-dd :syntax)
	  emit-div* (emit-div :syntax)
	  emit-dl* (emit-dl :syntax)
	  emit-dt* (emit-dt :syntax)
	  emit-fieldset* (emit-fieldset :syntax)
	  emit-form* (emit-form :syntax)
	  emit-h1* (emit-h1 :syntax)
	  emit-h2* (emit-h2 :syntax)
	  emit-h3* (emit-h3 :syntax)
	  emit-h4* (emit-h4 :syntax)
	  emit-h5* (emit-h5 :syntax)
	  emit-h6* (emit-h6 :syntax)
	  emit-head* (emit-head :syntax)
	  emit-html* (emit-html :syntax)
	  emit-label* (emit-label :syntax)
	  emit-legend* (emit-legend :syntax)
	  emit-li* (emit-li :syntax)
	  emit-map* (emit-map :syntax)
	  emit-noscript* (emit-noscript :syntax)
	  emit-object* (emit-object :syntax)
	  emit-ol* (emit-ol :syntax)
	  emit-optgroup* (emit-optgroup :syntax)
	  emit-option* (emit-option :syntax)
	  emit-p* (emit-p :syntax)
	  emit-pre* (emit-pre :syntax)
	  emit-samp* (emit-samp :syntax)
	  emit-script* (emit-script :syntax)
	  emit-select* (emit-select :syntax)
	  emit-style* (emit-style :syntax)
	  emit-table* (emit-table :syntax)
	  emit-tbody* (emit-tbody :syntax)
	  emit-td* (emit-td :syntax)
	  emit-textarea* (emit-textarea :syntax)
	  emit-tfoot* (emit-tfoot :syntax)
	  emit-th* (emit-th :syntax)
	  emit-thead* (emit-thead :syntax)
	  emit-title* (emit-title :syntax)
	  emit-tr* (emit-tr :syntax)
	  emit-ul* (emit-ul :syntax)
	  emit-applet* (emit-applet :syntax)
	  emit-center* (emit-center :syntax)
	  emit-dir* (emit-dir :syntax)
	  emit-frame* (emit-frame :syntax)
	  emit-frameset* (emit-frameset :syntax)
	  emit-iframe* (emit-iframe :syntax)
	  emit-menu* (emit-menu :syntax)
	  emit-noframes* (emit-noframes :syntax) ))


;;; Structures

(define-structures
  ((syntuls syntuls-face)
   (listuls listuls-face)
   (struls struls-face)
   (tourp tourp-face))
   (open list-lib   ; fold 
	 let-opt
	 string-lib 
	 scsh       ; IO, error
	 scheme)
   (for-syntax (open scheme))
   (files krims))


;; auxiliary structures that provide the bindings for macro expanders
;; and variables the expanders introduce in the expanded code
(define-structures
  ((doedel-compiler-pkg (export compile-infocule))
   (doedel-support-pkg
    (export dt-html4s dt-html4l dt-html4f
	    ipret-infocule really-ipret-infocule ipret-punct extend-ic-grammar
	    pair-for-each first second
	    format))
   (taggers-expander-pkg (export expand-db expand-dp))
   (taggers-support-pkg
     (export emit-komment emit-bracket emit-punct))
   )
  (open syntuls     ; with-renames 
	listuls	    ; pair-map
	list-lib    ; first second third member append! pair-for-each
        scsh        ; IO error
	scheme)
  (files doedel)
  (optimize auto-integrate))


(define-structure doedelities doedel-face
  (open doedel-support-pkg tourp let-opt scheme)
  (for-syntax (open doedel-compiler-pkg scheme))
  (begin
    (define (doedel* out e . args)
      (define preamble (:optional args dt-html4s))
      (with-current-opout-tourp out
        (ipret-infocule preamble)
	(ipret-infocule e)))

    (define-syntax doedelite
      (lambda (e r c)
	(compile-infocule (cadr e) r c)))

    (define-syntax doedel
      (syntax-rules ()
	((doedel out e preamble)
	 (with-current-opout-tourp out
           (display preamble)
	   (newline)
	   (doedelite e)))
	((doedel out e)
	 (doedel out e dt-html4s))))

    ;; EXTEND-DOEDEL/-IC-GRAMMAR think global, no refinements, no thought
    ;; about modules.
    (define-syntax extend-doedel
      (syntax-rules ()
	((extend-doedel kw tf)
	 (extend-ic-grammar 'kw tf))))

    ;; in s48, (SYNTAX-RULES () R0 ...) evaluates to a list (TF V0 ...)
    ;; of an explicit-renaming transform TF and the free names V0, ...
    ;; the rules R0 ... introduce.  Now, I (or let's say: we) simply take
    ;; the transform and -- dead and be damned and the rest gone whist!
    ;; Yohoho and a bottle of rum.  (The expander cheats on its turn, so that
    ;; we usually don't stumble over generated names and fall on the nose,
    ;; right in the mud I've coded up.)
    (define-syntax define-doedel-syntax
      (syntax-rules ()
	((define-doedel-syntax kw sr)
	 (extend-ic-grammar 'kw (car sr))))) ))	; bogus

      


(define-structure taggers taggers-face
  (open taggers-support-pkg scheme)
  (for-syntax (open taggers-expander-pkg scheme))
  (begin
    (define-syntax define-bracket expand-db)
    (define-syntax define-punct expand-dp)) )


(define-structure eltern eltern-face
  (open taggers scheme)
  (files html-elter))



;; for no particular purpose
(define-structure doedel-testbed (export )
  (open eltern taggers doedelities string-lib list-lib scsh scheme))
