; stem version --> http://www.schnada.de/progn/hax.html#doedel
; cf. Readme

;; broken feature, just for demo
;; The extended DOEDEL forms work as advertised when the code is evaluated
;; at the prompt, not when it's ,loaded.
;; Cf. comments in: Readme doedel.scm doedules.scm
(define-doedel-syntax uli
  (syntax-rules ()
    ((uli (?url ?text) ...)
     (ul ()
       (li () (a ((href ?url)) ?text)) ...))))

(let ((name "Doug Schwartzbrenner")
      (email "dsb@broccoli.org")
      (home 'http://www.karnivor.net/doug/)
      (images '(raw.jpg juicy.jpg salted.jpg burnt.jpg)))

  (define (emit-blob name email)
    (doedelite (address ((lang de))
		 Mainteniert bei
		 (a ((href ,(string-append "mailto:"email))) ,name)
		 "(dsb@broccoli.org)")))

  (define (emit-sth-0 out images)
    (doedel out
      (body ((lang en))
	(h1 () Young Meat)
	(p ()
	  ,@(apply append
		   (map (lambda (name)
			  `((img ((src ,name)))
			    (br ())))
			images))
	  (sticky in(em () cred))ible
	  "Trude Mller, 18")

	(h2 () Members)
	(uli ("foo.html#jinx" Fred)
	     (baz/wim.html Zbigniev)
	     (,home ,name))

	(hr ())
	(begin (emit-blob name email)))
      dt-html4l))

  ;; Take the definition above, replace the DOEDEL form by the DOEDEL*
  ;; procedure, putting a backquote in front of the <infocule> form
  ;; and substituting (LAMBDA () ...) for the <infocule> subform (BEGIN ...)
  ;; Voil, that's what you get:
  (define (emit-sth-1 out images)
    (doedel* out `(body ((lang en))
		    (h1 () Young Meat)
		      (p ()
			,@(apply append
				 (map (lambda (name)
					`((img ((src ,name)))
					  (br ())))
				      images))
			(sticky in(em () cred))ible
			"Trude Mller, 18")

		      (h2 () Members)
		      (uli ("foo.html#jinx" Fred)
			   (baz/wim.html Zbigniev)
			   (,home ,name))

		      (hr ())
		      ,(lambda () (emit-blob name email)))
	     dt-html4l))
  
  ;; they should agree
  (with-output-to-file "trude.html"
    (lambda () (emit-sth-0 #t images)))
  (format #t "DOEDEL and DOEDEL* ~A.~%"
	  (if (string=? (emit-sth-0 #f images)
			(emit-sth-1 #f images))
	      'agree
	      'differ)))


;;; An alternative approach

;; broken feature, just for demo
(define-syntax olala
  (syntax-rules ()
    ((olala (?url ?text) ...)
     (emit-ol ()
       (emit-li ()
         (emit-a ((href ?url))
	   (display `?text)
	   (newline)))
       ...))))

;; if you don't like the predefined EMIT-FOO names choose your own:
(begin
  (define-bracket corpus body)
  (define-bracket h1 h1)
  (define-bracket h2 h2)
  (define-bracket a a)
  (define-bracket em em)
  (define-bracket li li)
  (define-bracket p p)
  
  (define-punct br br)
  (define-punct img img)
  (define-punct hr hr))

(let ((name "Doug Schwartzbrenner")
      (email "dsb@broccoli.org")
      (home 'http://www.karnivor.net/doug/)
      (images '(raw.jpg juicy.jpg salted.jpg burnt.jpg)))

  (define (emit-blob name email)
    (emit-address ((lang de))
      (display "Mainteniert bei \n")
      (emit-a ((href ,(string-append "mailto:"email)))
        (display name))
      (display " (dsb@broccoli.org) \n")))

  (define (emit-sth-2 out images)
    (format out "~A~%" dt-html4l) 
    (corpus ((lang en))
      (h1 () (display "Young Meat"))
      (newline)

      (p ()
        (for-each (lambda (name)
		    (img ((src ,name)))
		    (br ())
		    (newline))
		  images)
	(display 'in)
	(em () (display 'cred))
	(display 'ible)
	(display " Gerda Mller, 18"))
      (newline)

      (h2* '() (lambda () (display 'Members))) ; for a change
      (newline)
      (olala ("foo.html#jinx" Fred)
	     (baz/wim.html Zbigniev)
	     (,home ,name))
      (newline)

      (hr ())
      (emit-blob name email)))

  (with-output-to-file "gerda.html"
    (lambda () (emit-sth-2 #t images))))
